summaryrefslogtreecommitdiffstats
path: root/source/xap/rxvt-unicode
diff options
context:
space:
mode:
Diffstat (limited to 'source/xap/rxvt-unicode')
-rw-r--r--source/xap/rxvt-unicode/CVE-2022-4170.diff12
-rwxr-xr-xsource/xap/rxvt-unicode/rxvt-unicode.SlackBuild5
2 files changed, 16 insertions, 1 deletions
diff --git a/source/xap/rxvt-unicode/CVE-2022-4170.diff b/source/xap/rxvt-unicode/CVE-2022-4170.diff
new file mode 100644
index 000000000..95edd1221
--- /dev/null
+++ b/source/xap/rxvt-unicode/CVE-2022-4170.diff
@@ -0,0 +1,12 @@
+--- ./src/perl/background.orig 2021-05-09 10:04:44.000000000 -0500
++++ ./src/perl/background 2023-01-03 13:53:59.865031717 -0600
+@@ -1451,8 +1451,7 @@
+ # any code execution or other shenanigans. does not
+ # support binary NULs in string.
+ sub q0 {
+- (my $str = shift) =~ s/\x00//g; # make sure there really aren't any embedded NULs
+- "q\x00$str\x00"
++ "qq\x00\Q$_[0]\E\x00"
+ }
+
+ sub old_bg_expr {
diff --git a/source/xap/rxvt-unicode/rxvt-unicode.SlackBuild b/source/xap/rxvt-unicode/rxvt-unicode.SlackBuild
index 92ea28cc1..79e633f54 100755
--- a/source/xap/rxvt-unicode/rxvt-unicode.SlackBuild
+++ b/source/xap/rxvt-unicode/rxvt-unicode.SlackBuild
@@ -24,7 +24,7 @@ cd $(dirname $0) ; CWD=$(pwd)
PKGNAM=rxvt-unicode
VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
-BUILD=${BUILD:-3}
+BUILD=${BUILD:-4}
# Automatically determine the architecture we're building on:
if [ -z "$ARCH" ]; then
@@ -88,6 +88,9 @@ find . \
# Add support for utempter:
zcat $CWD/rxvt-unicode.utempter.diff.gz | patch -p1 --verbose || exit 1
+# Security fix:
+zcat $CWD/CVE-2022-4170.diff.gz | patch -p1 --verbose || exit 1
+
# Regenerate configure from configure.ac after patching in utempter support:
autoreconf -vif